c------------------------------------------c
c  Program Shift                           c
c  Circular Shift                          c
c------------------------------------------c

      program main


      implicit none

      include 'mpif.h'
      integer i
      integer ierr, rank, size
      integer tag, count, dest, source
      integer MSIZE
      parameter(MSIZE=50000)
      integer A(MSIZE), B(MSIZE)

      integer status(MPI_STATUS_SIZE)

c     cartesian topology 
      logical periods(1)
      integer dims(1), comm_cart

c--- Start up MPI  ----------- ----------------------------------------------
      call MPI_INIT(ierr)
      call MPI_COMM_RANK(MPI_COMM_WORLD,rank,ierr)
      call MPI_COMM_SIZE(MPI_COMM_WORLD,size,ierr)


      do i=1,MSIZE
         A(i)=rank
      enddo

c--- sending/receiving arraies A and B --------------------------------------
      tag=201

      dims(1) = 0
      periods(1) = .TRUE.
      call MPI_Dims_create(size, 1, dims, ierr)
      call MPI_Cart_create(MPI_COMM_WORLD, 1, dims, periods, .FALSE., 
     &   comm_cart, ierr)

      call MPI_Cart_shift(comm_cart, 0, 1, source, dest, ierr)
      call MPI_Sendrecv(A, MSIZE, MPI_INTEGER, dest, tag, B, MSIZE, 
     &   MPI_INTEGER, source, tag, MPI_COMM_WORLD, status, ierr)



      print *,'Proc',rank,'sends',MSIZE,'integers to proc',dest
      print *,'Proc',rank,'receives',MSIZE,'integers from proc',source



c--- print first content of array A and B -----------------------------------

      print *,'Proc',rank,'has A(1) =',A(1),' and B(1)=',B(1)

c--- QUIT -------------------------------------------------------------------

      call MPI_FINALIZE(ierr)

      end
